﻿using System;
using System.Collections.Generic;
using System.Data.SQLite;
using System.Globalization;
using System.Text;
using ClosedXML.Excel;

namespace Module1
{
    /// <summary>
    /// analyse d'une class visite venant de la bdd selon le param eating
    /// </summary>
    class AnalysVisit
    {
        Visit m_visit= new Visit();
        List<Eating> m_eatings = new List<Eating>();
        Dictionary<DateTime,int> m_DateTimeBool =new Dictionary<DateTime, int>();

        public AnalysVisit(string subject, int through, DateTime date_start, DateTime stringdate_end)
        {
            SQLiteConnection connection = new SQLiteConnection("Data Source=referencedb.db");
            connection.Open();
            SQLiteCommand command = new SQLiteCommand(connection);
            
            //selection de la visite dans la base
            command.CommandText = $"SELECT * FROM visite WHERE subject == '{subject}' AND trough == {through} AND start_date == '{date_start.ToString("yyyy-MM-dd HH:mm:ss.fff")}' AND end_date == '{stringdate_end.ToString("yyyy-MM-dd HH:mm:ss.fff")}'";
            using SQLiteDataReader rdr = command.ExecuteReader();
            int id = 0;
            while (rdr.Read())
            {
                m_visit.m_trough = Int32.Parse(rdr["trough"].ToString());
                m_visit.m_subject = rdr["subject"].ToString();
                m_visit.m_dt_start_time = rdr.GetDateTime(3);
                m_visit.m_dt_end_time = rdr.GetDateTime(4);
              
                //Console.WriteLine(rdr.GetString(1));
                id = Int32.Parse(rdr["id"].ToString());
            }


            rdr.Close();
            //selection des eatings
            command.CommandText = $"SELECT * FROM eating WHERE id_visit == '{id}'";
            using SQLiteDataReader rdr2 = command.ExecuteReader();
            
            while (rdr2.Read())
            {
                m_eatings.Add(new Eating(Int32.Parse(rdr2["id_visit"].ToString()), rdr2.GetDateTime(2), rdr2.GetDateTime(3)));
                //Console.WriteLine(rdr2["id_visit"]);
                //Console.WriteLine(rdr2["start_date"]);
                //Console.WriteLine(rdr2["end_date"]);
               
            }

            //verification console
            //foreach (var item in m_eatings)
            //{
            //    Console.WriteLine(item.m_id_visite);
            //    Console.WriteLine(item.m_start_time);
            //    Console.WriteLine(item.m_end_time);
            //}

        }

        public void GenerateValues(string arrondir)
        {
            Console.WriteLine("Debut  dt\n");
            var provider = new CultureInfo("fr-FR");
            var format = "dd/MM/yyyy HH:mm:ss.fff";
            //DateTime firstdatevisit =  DateTime.ParseExact(m_visit.m_start_time, format, provider);
            DateTime firstdatevisit = m_visit.m_dt_start_time;

            //DateTime lastdatevisit = DateTime.ParseExact(m_visit.m_end_time, format, provider);
            DateTime lastdatevisit = m_visit.m_dt_end_time;

            //DateTime debutdatetime = new DateTime(firstdatevisit.Year, firstdatevisit.Month, firstdatevisit.Day, firstdatevisit.Hour, firstdatevisit.Minute, firstdatevisit.Second , firstdatevisit.Millisecond);

            DateTime debutdatetime = firstdatevisit;
            if (arrondir == "milliseconde")
            {
                if (debutdatetime.Millisecond > 500)
                {
                    debutdatetime = debutdatetime.AddMilliseconds(500);
                }
                else
                {
                    debutdatetime = debutdatetime.AddMilliseconds(debutdatetime.Millisecond - debutdatetime.Millisecond);
                }
            }
            else
            {
                debutdatetime = debutdatetime.AddMilliseconds(debutdatetime.Millisecond - debutdatetime.Millisecond);
            }
            Eating eatingcourant = m_eatings[0];
            int compt=0;
            //remplir le dictio
            for (DateTime tempDatetime = debutdatetime; tempDatetime <= lastdatevisit; tempDatetime = tempDatetime.AddSeconds(1))
            {

                //regarder si tempdeatetime est avant eatingcourant
                if (tempDatetime < eatingcourant.m_dt_start_time)
                {
                    m_DateTimeBool.Add(tempDatetime, 0);
                }
                else if(tempDatetime < eatingcourant.m_dt_end_time)
                {
                    m_DateTimeBool.Add(tempDatetime, 1);
                }
                else
                {
                    compt++;
                    if (compt >= m_eatings.Count)
                    {
                        compt = 0;
                    }
                    eatingcourant = m_eatings[compt];
                }
            }
            
            //ajouter les données de début / fin des moments ou l'animal mange
            foreach (var eating in m_eatings)
            {
                DateTime eatingstart = eating.m_dt_start_time;
                
                m_DateTimeBool.Add(eatingstart, 1);
 
                DateTime eatingstop = eating.m_dt_end_time;
                m_DateTimeBool.Add(eatingstop, 0);

            }

            Program.VerifyDictionary(m_DateTimeBool);



        }


    }
}
