﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Text;

namespace Module1
{
    class Visit
    {
        public string m_subject;
        public int m_trough;
        public string m_start_time;
        public string m_end_time;

        public DateTime m_dt_start_time, m_dt_end_time;
        //contructeur vide 
        public Visit()
        {

        }

        public Visit(string subject, int trough, string start, string end)
        {
            m_subject = subject;
            m_trough = trough;
            m_end_time = end;
            m_start_time = start;
        }

        public DateTime GetDatetimeStart()
        {
            var provider = new CultureInfo("fr-FR");
            var format = "dd/MM/yyyy HH:mm:ss.fff";
            if (m_start_time.Length == 22)
            {
                m_start_time = m_start_time+"0";
            }
            DateTime dt = DateTime.ParseExact(m_start_time, format, provider);

            return dt;
        }

        public DateTime GetDatetimeEnd()
        {
            var provider = new CultureInfo("fr-FR");
            var format = "dd/MM/yyyy HH:mm:ss.fff";
            if (m_end_time.Length == 22)
            {
                m_end_time = m_end_time+"0";
            }
            DateTime dt = DateTime.ParseExact(m_end_time, format, provider);

            return dt;
        }
    }
}
