﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Text;

namespace Module1
{
    class Eating
    {
        public int m_id_visite;
        public string m_start_time, m_end_time;
        public DateTime m_dt_start_time, m_dt_end_time;
        //contructeur vide 
        public Eating()
        {

        }

        public Eating(int id_visite, DateTime dtstart, DateTime dtend)
        {
            m_dt_start_time = dtstart;
            m_id_visite = id_visite;
            m_dt_end_time = dtend;
        }

        public DateTime GetDatetimeStart()
        {
            var provider = new CultureInfo("fr-FR");
            var format = "dd/MM/yyyy HH:mm:ss.fff";
            if (m_start_time.Length == 22)
            {
                m_start_time = m_start_time + "0";
            }
            DateTime dt = DateTime.ParseExact(m_start_time, format, provider);
  
            return dt;
        }

        public DateTime GetDatetimeEnd()
        {
            var provider = new CultureInfo("fr-FR");
            var format = "dd/MM/yyyy HH:mm:ss.fff";
            if (m_end_time.Length == 22)
            {
                m_end_time = m_end_time + "0";
            }
            
            DateTime dt = DateTime.ParseExact(m_end_time, format, provider);

            return dt;
        }

    }
}
