﻿using System;

namespace SmartCowBioControl.src.objects
{
    public class RapidObject
    {
        public int Animal { get; private set; }
        public DateTime DateHeureReference { get; set; }
        public DateTime DateHeureDephasage { get; set; }
        public double Poids { get; set; }

        public RapidObject Clone => new RapidObject(this.Animal, this.DateHeureReference, this.Poids);

        public RapidObject(int animal, DateTime dateHeure, double poids)
        {
            this.Animal = animal;
            this.DateHeureReference = dateHeure;
            this.DateHeureDephasage = dateHeure;
            this.Poids = poids;
        }
    }
}
