﻿using System;
using System.Globalization;

namespace SmartCowBioControl.src.database
{
    /// <summary>
    /// Visite.
    /// </summary>
    class VisiteDatabase
    {
        // ====================================================================================================
        // PROPRIETES
        // ====================================================================================================

        public string Animal;
        public int Auge;
        public string DateHeureDebut;
        public string DateHeureFin;

        public DateTime m_dt_start_time, m_dt_end_time;

        public VisiteDatabase(string animal, int auge, string start, string end)
        {
            Animal = animal;
            Auge = auge;
            DateHeureDebut = start;
            DateHeureFin = end;
        }

        public DateTime GetDatetimeStart()
        {
            var provider = new CultureInfo("fr-FR");
            var format = "dd/MM/yyyy HH:mm:ss.fff";
            if (DateHeureDebut.Length == 22)
            {
                DateHeureDebut = DateHeureDebut + "0";
            }
            DateTime dt = DateTime.ParseExact(DateHeureDebut, format, provider);

            return dt;
        }

        public DateTime GetDatetimeEnd()
        {
            var provider = new CultureInfo("fr-FR");
            var format = "dd/MM/yyyy HH:mm:ss.fff";
            if (DateHeureFin.Length == 22)
            {
                DateHeureFin = DateHeureFin + "0";
            }
            DateTime dt = DateTime.ParseExact(DateHeureFin, format, provider);

            return dt;
        }
    }
}
