﻿using System;

namespace Stage_Interface
{
    /// <summary>
    /// Classe abstraite pour choisir un fichier de type rapid dans son constructeur
    /// </summary>
    abstract class Rapid
    {
        /// <summary>
        ////string contenant le chemin du fichier "rapide" qui est actuellement traité
        /// </summary>
        protected string m_CurrentRapidFile = String.Empty;

        /// <summary>
        /// constructeur du fichier 
        /// </summary>
        /// <param name="pathRapidFile"> Chemin du fichier rapide ou l'on travail </param>
        public Rapid(string pathRapidFile)
        {
            m_CurrentRapidFile = pathRapidFile;
        }

    }
}
