﻿namespace SmartCowBioControl.src.calcul
{
    public class Parametres
    {
        // ====================================================================================================
        // PROPRIETES
        // ====================================================================================================

        public bool IsPasDeTempsActif { get; set; }

        public bool IsFiltreHauteFrequenceActif { get; set; }

        public bool IsFiltreBasseFrequenceActif { get; set; }

        public bool IsNormalisationActif { get; set; }

        public bool IsSeuilActif { get; set; }

        public int PasDeTemps { get; set; }

        public double FiltreHauteFrequence { get; set; }

        public int FiltreBasseFrequence { get; set; }

        public double Seuil { get; set; }

        public int IntervalleDeTemps { get; set; }

        public int DecalageDansVisite { get; set; }

        public int Dephasage { get; set; }

        // ====================================================================================================
        // CONSTRUCTEURS
        // ====================================================================================================

        public Parametres()
        {
            this.PasDeTemps = 1;
            this.FiltreBasseFrequence = 15;
            this.FiltreHauteFrequence = 3;
            this.IntervalleDeTemps = 5;
        }
    }
}
