﻿using System;

namespace SmartCowBioControl.src.objects
{
    /// <summary>
    /// Intervalle de temps où l'animal mange.
    /// </summary>
    public class Eating
    {
        // ====================================================================================================
        // PROPRIETES
        // ====================================================================================================

        public int IdVisite { get; set; }

        public DateTime DateHeureDebut { get; private set; }

        public DateTime DateHeureFin { get; set; }

        // ====================================================================================================
        // CONSTRUCTEURS
        // ====================================================================================================

        /// <summary>
        /// Constructeur.
        /// </summary>
        /// <param name="idVisite"></param>
        /// <param name="dateHeureDebut"></param>
        /// <param name="dateHeureFin"></param>
        public Eating(int idVisite, DateTime dateHeureDebut, DateTime dateHeureFin)
        {
            this.IdVisite = idVisite;
            this.DateHeureDebut = dateHeureDebut;
            this.DateHeureFin = dateHeureFin;
        }
    }
}
